// CommDrv.cpp : Cve[V t@C
//V1.01 96,12,13 XV
//V1.02 1997,5,27 XV
//V1.03 1998,1,28 XV
//Copyright(C) 2008 X F

#include "stdafx.h"
#include "CommDrv.h"

#include <winbase.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
//g
//	CComm Comm;
//	Comm.SOpen(...);
//	Comm.SRead(...);
//	Comm.Close();
//܂
//	CComm* pComm = new CComm;
//	pComm->SOpen(...);
//	pComm->SRead(...);
//
//	pComm->Close();
//	delete pComm;

//
CComm::CComm()
{
	m_portName = _T("");
	m_hComm = 0;
	memset (&m_dcb, 0, sizeof(DCB)); 
	memset (&m_os, 0, sizeof(OVERLAPPED)); 
}

CComm::~CComm()
{
	if(m_hComm)	CloseHandle(m_hComm);

}

//񓯊̂߂̃I[v
//2400bps, 7bit, even parity, 1 stopbit
BOOL CComm::AOpen(CString name)
{
	BOOL result;
//	CComm* pComm = new CComm();
	
	if ((m_hComm = CreateFile(CString("\\\\.\\")+name, 
			GENERIC_READ | GENERIC_WRITE,
			0,
			NULL,
			OPEN_EXISTING,
			FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED,
			NULL)) == (HANDLE) -1) {
		AfxMessageBox(name + CString(": can't open\n"));
		return FALSE;
	}
	result = SetCommMask (m_hComm, EV_RXCHAR);
	result = SetupComm (m_hComm, 1024, 1024);
	result = PurgeComm (m_hComm, PURGE_TXABORT | PURGE_RXABORT);
	result = GetCommTimeouts (m_hComm, &m_CommTimeOuts);
	m_CommTimeOuts.ReadTotalTimeoutConstant = 5000;
	result = SetCommTimeouts (m_hComm, &m_CommTimeOuts);
	// setup m_dcb
	m_dcb.DCBlength = sizeof(DCB);
	result = GetCommState (m_hComm, &m_dcb);
	m_dcb.BaudRate = 2400;
	m_dcb.ByteSize = 7;
	m_dcb.Parity = 2;	// even
	m_dcb.StopBits = 0;
	m_dcb.fOutxDsrFlow = FALSE;	// FC_DTRDSR = 0x01;
	m_dcb.fDtrControl = DTR_CONTROL_ENABLE;
	m_dcb.fOutxCtsFlow = FALSE;	// FC_RTSCTS = 0x02 
	m_dcb.fRtsControl = 3;
	m_dcb.fInX = m_dcb.fOutX = TRUE;
	m_dcb.XonChar = 0x11; // ASCII_XON;
	m_dcb.XoffChar = 0x13; //ASCII_XOFF;
	m_dcb.XonLim = 100;
	m_dcb.XoffLim = 100;
	m_dcb.fBinary = TRUE;
	m_dcb.fParity = TRUE;
	result = SetCommState (m_hComm, &m_dcb);

	memset (&m_os, 0, sizeof(OVERLAPPED)); 
	m_os.hEvent = CreateEvent (NULL,
							TRUE,
							FALSE,
							NULL);
	result = SetCommMask (m_hComm, EV_RXCHAR);
	return TRUE;
}


//1siCR,LF܂Łjǂ
//Cxggp
int CComm::AReadLine(char buf[])
{
	ASSERT(m_hComm);
	DWORD dwLen, dwEventMask;
	BOOL result;
	DWORD dwErrorFlags;
	COMSTAT ComStat;
	int pos;
	BOOL fCRLF;

	ASSERT(m_hComm);
	dwEventMask = 0;
	pos = 0;
	result = TRUE;
	fCRLF = FALSE;
	while (result == TRUE && fCRLF == FALSE) {
		result = WaitCommEvent (m_hComm, &dwEventMask, NULL);
		dwLen = 1;
		while ( dwLen > 0 && fCRLF == FALSE ) {
			ClearCommError (m_hComm, &dwErrorFlags, &ComStat);
			dwLen = min(1024, ComStat.cbInQue);
			result = ReadFile (m_hComm, &buf[pos], dwLen, &dwLen, &m_os);  
			if (result)
				pos += dwLen;
			buf[pos] = '\0';
			if (strchr(buf, '\r') && strchr(buf, '\n'))
				fCRLF = TRUE;
		}
	}
	if (fCRLF == TRUE)
		buf[pos-2] = '\0';

	return pos-2;
}

void CComm::Close()
{
	ASSERT(m_hComm);
	CloseHandle(m_hComm);
	m_hComm = 0;
//	delete this;
}

//12/10
//̂߂̃I[v
//2400bps, 7bit, even parity, 1 stopbit
BOOL CComm::SOpen(CString name)
{
	BOOL result;
//	CComm* pComm = new CComm();
	
	if ((m_hComm = CreateFile(CString("\\\\.\\")+name, 
			GENERIC_READ | GENERIC_WRITE,
			0,
			NULL,
			OPEN_EXISTING,
			FILE_ATTRIBUTE_NORMAL,
			NULL)) == (HANDLE) -1) {
		AfxMessageBox(name + CString(": can't open\n"));
		return FALSE;
	}
	result = SetCommMask (m_hComm, EV_RXCHAR);
	result = SetupComm (m_hComm, 1024, 1024);
	result = PurgeComm (m_hComm, PURGE_TXABORT | PURGE_RXABORT);
	result = GetCommTimeouts (m_hComm, &m_CommTimeOuts);
	m_CommTimeOuts.ReadTotalTimeoutConstant = 5000;
	result = SetCommTimeouts (m_hComm, &m_CommTimeOuts);
	// setup m_dcb
	m_dcb.DCBlength = sizeof(DCB);
	result = GetCommState (m_hComm, &m_dcb);
	m_dcb.BaudRate = 2400;
	m_dcb.ByteSize = 7;
	m_dcb.Parity = 2;	// even
	m_dcb.StopBits = 0;
	m_dcb.fOutxDsrFlow = FALSE;	// FC_DTRDSR = 0x01;
	m_dcb.fDtrControl = DTR_CONTROL_ENABLE;
	m_dcb.fOutxCtsFlow = FALSE;	// FC_RTSCTS = 0x02 
	m_dcb.fRtsControl = 3;
	m_dcb.fInX = m_dcb.fOutX = TRUE;
	m_dcb.XonChar = 0x11; // ASCII_XON;
	m_dcb.XoffChar = 0x13; //ASCII_XOFF;
	m_dcb.XonLim = 100;
	m_dcb.XoffLim = 100;
	m_dcb.fBinary = TRUE;
	m_dcb.fParity = TRUE;
	result = SetCommState (m_hComm, &m_dcb);

	memset (&m_os, 0, sizeof(OVERLAPPED)); 
//	m_os.hEvent = CreateEvent (NULL,
//							TRUE,
//							FALSE,
//							NULL);
	result = SetCommMask (m_hComm, EV_RXCHAR);
	return TRUE;
}

//97,10,4
//̂߂̃I[v
//RTSt[gp
BOOL CComm::SOpenEx(CString name,		//com? (ex. com1,com2,...)
					  DWORD BaudRate,
					  BYTE	ByteSize,
					  BYTE	Parity,
					  BYTE	StopBits)
{
	BOOL result;
//	CComm* pComm = new CComm();
	
	if ((m_hComm = CreateFile(CString("\\\\.\\")+name, 
			GENERIC_READ | GENERIC_WRITE,
			0,
			NULL,
			OPEN_EXISTING,
			FILE_ATTRIBUTE_NORMAL,
			NULL)) == (HANDLE) -1) {
		AfxMessageBox(name + CString(": can't open\n"));
		return FALSE;
	}
	result = SetCommMask (m_hComm, EV_RXCHAR);
	result = SetupComm (m_hComm, 1024, 1024);
	result = PurgeComm (m_hComm, PURGE_TXABORT | PURGE_RXABORT);
	result = GetCommTimeouts (m_hComm, &m_CommTimeOuts);
	m_CommTimeOuts.ReadTotalTimeoutConstant = 5000;
	result = SetCommTimeouts (m_hComm, &m_CommTimeOuts);
	// setup m_dcb
	m_dcb.DCBlength = sizeof(DCB);
	result = GetCommState (m_hComm, &m_dcb);
	m_dcb.BaudRate = BaudRate;	// <<<<
	m_dcb.fBinary = TRUE;		//always
	if (Parity == NOPARITY)
		m_dcb.fParity = FALSE;
	else
		m_dcb.fParity = TRUE;
	m_dcb.fOutxCtsFlow = TRUE;	// FC_RTSCTS = 0x02 
	m_dcb.fOutxDsrFlow = TRUE;	// FC_DTRDSR = 0x01;
	m_dcb.fDtrControl = DTR_CONTROL_HANDSHAKE;
	m_dcb.fDsrSensitivity = TRUE;
	m_dcb.fTXContinueOnXoff = FALSE;
	m_dcb.fOutX = FALSE;
	m_dcb.fInX = FALSE;
//	m_dcb.fErrorChar = FALSE;
//	m_dcb.fNull = FALSE;
	m_dcb.fRtsControl = RTS_CONTROL_HANDSHAKE;
//	m_dcb.fAbortOnError = FALSE;
	m_dcb.wReserved = 0;
	m_dcb.XonLim = 100;
	m_dcb.XoffLim = 100;
	m_dcb.ByteSize = ByteSize;	// <<<<
	m_dcb.Parity = Parity;		// <<<<
	m_dcb.StopBits = StopBits;	// <<<<
//	m_dcb.XonChar = 0x11;		// ASCII_XON;
//	m_dcb.XoffChar = 0x13;		//ASCII_XOFF;
//	m_dcb.ErrorChar = '\\';
//	m_dcb.EofChar = 0x00;
//	m_dcb.EvtofChar = 0x00;

	result = SetCommState (m_hComm, &m_dcb);

	memset (&m_os, 0, sizeof(OVERLAPPED)); 
//	m_os.hEvent = CreateEvent (NULL,
//							TRUE,
//							FALSE,
//							NULL);
	result = SetCommMask (m_hComm, EV_RXCHAR);
	return TRUE;
}

//Mobt@NA
BOOL CComm::Purge( DWORD dwFlags )
{
	ASSERT(m_hComm);
	return PurgeComm( m_hComm, dwFlags );
}

//1ǂށiCxggpȂj
//timeout = 0		 : |[O
//			MAXDWORD : iv҂
unsigned int CComm::SGetChar( DWORD timeout )
{
	DWORD	dwLen = 0;
	BOOL	result;
	DWORD	dwErrorFlags;
	COMSTAT ComStat;
	char	buf;
	ASSERT(m_hComm);
	result = GetCommTimeouts (m_hComm, &m_CommTimeOuts);
	switch(timeout){
	case 0:
		//|[O
		m_CommTimeOuts.ReadIntervalTimeout = MAXDWORD;
		m_CommTimeOuts.ReadTotalTimeoutConstant = 0;
		m_CommTimeOuts.ReadTotalTimeoutMultiplier = 0;
		break;
	case MAXDWORD:
		//iv҂
		m_CommTimeOuts.ReadIntervalTimeout = 0;
		m_CommTimeOuts.ReadTotalTimeoutConstant = 0;
		m_CommTimeOuts.ReadTotalTimeoutMultiplier = 0;
		break;
	default:
		m_CommTimeOuts.ReadIntervalTimeout = 0;
		m_CommTimeOuts.ReadTotalTimeoutConstant = timeout;
		break;
	}
	result = SetCommTimeouts (m_hComm, &m_CommTimeOuts);
	ClearCommError (m_hComm, &dwErrorFlags, &ComStat);
	result = ReadFile (m_hComm, &buf, 1, &dwLen, &m_os);	//1oCgǂ 
	if (result && dwLen) return buf;
	return (unsigned int)-1;	//f[^Ȃ
}

//ǂށiCxggpȂj
//timeout = 0		 : |[O
//			MAXDWORD : iv҂
int CComm::SRead( char buf[], int count, DWORD timeout )
{
	DWORD	dwLen = 0;
	BOOL	result;
	DWORD	dwErrorFlags;
	COMSTAT ComStat;
	ASSERT(m_hComm);
	result = GetCommTimeouts (m_hComm, &m_CommTimeOuts);
	switch(timeout){
	case 0:
		//|[O
		m_CommTimeOuts.ReadIntervalTimeout = MAXDWORD;
		m_CommTimeOuts.ReadTotalTimeoutConstant = 0;
		m_CommTimeOuts.ReadTotalTimeoutMultiplier = 0;
		break;
	case MAXDWORD:
		//iv҂
		m_CommTimeOuts.ReadIntervalTimeout = 0;
		m_CommTimeOuts.ReadTotalTimeoutConstant = 0;
		m_CommTimeOuts.ReadTotalTimeoutMultiplier = 0;
		break;
	default:
		m_CommTimeOuts.ReadIntervalTimeout = 0;
		m_CommTimeOuts.ReadTotalTimeoutConstant = timeout;
		break;
	}
	result = SetCommTimeouts (m_hComm, &m_CommTimeOuts);
	ClearCommError (m_hComm, &dwErrorFlags, &ComStat);
	result = ReadFile (m_hComm, buf, count, &dwLen, &m_os);	//ǂ 
	if ( result ) return dwLen;
	return 0;	//f[^Ȃ
}

//iCxggpȂj
//timeout = 0		 : |[O
//			MAXDWORD : iv҂
int CComm::SWrite( char buf[], int count, DWORD timeout )
{
	DWORD	dwLen = 0;
	BOOL	result;
	DWORD	dwErrorFlags;
	COMSTAT ComStat;
	ASSERT(m_hComm);
	result = GetCommTimeouts (m_hComm, &m_CommTimeOuts);
	switch(timeout){
	case 0:
		//|[O
		m_CommTimeOuts.WriteTotalTimeoutConstant = 1;
		m_CommTimeOuts.WriteTotalTimeoutMultiplier = 1;
		break;
	case MAXDWORD:
		//iv҂
		m_CommTimeOuts.WriteTotalTimeoutConstant = 0;
		m_CommTimeOuts.WriteTotalTimeoutMultiplier = 0;
		break;
	default:
		m_CommTimeOuts.WriteTotalTimeoutConstant = timeout;
		break;
	}
	result = SetCommTimeouts (m_hComm, &m_CommTimeOuts);
	ClearCommError (m_hComm, &dwErrorFlags, &ComStat);
	result = WriteFile (m_hComm, buf, count, &dwLen, &m_os);	//
	if ( result ) return dwLen;
	return 0;	//f[^Ȃ
}



//BEGIN_MESSAGE_MAP(CComm, CCmdTarget)
//	//{{AFX_MSG_MAP(CComm)
//	//}}AFX_MSG_MAP
//END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CComm O[o֐

//sR[h܂œǂݎ
BOOL PollLineData( CComm* pComm, CString& data )
{
	int c;
	int count = 0;
	
	while(1){
		c = pComm->SGetChar( 0 );
		if (c == -1) return FALSE;
		++ count;
		if (count == 1) TRACE("comm data = ");
		TRACE1(" %02xh", c);
		data += (TCHAR)c;
		if ( c == '\n' ) break;
	}
	TRACE("\n");
	TRACE1("%d bytes received.\n", count);
	if (data.GetLength()){
		if (data.Find("\r\n") != -1){
			data.TrimRight();			//CR,LF폜
			return TRUE;
		}
	}
	return FALSE;
}
